#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <OS.h>


static sem_id sem;


static int32
snooze_thread_entry(void* data)
{
	while (true) {
		snooze(500000);
	}

	release_sem(sem);
	return 0;
}


int
main(int argc, char **argv)
{
	int32 threads = 16;
	
	if (argc > 1)
		threads = atoi(argv[1]);
	

	sem = create_sem(threads, "thread_sem");
		
	for (uint32 i = 0; i < threads; i++) {

		acquire_sem(sem);
		
		thread_id thread = 
			spawn_thread(snooze_thread_entry, "thread", B_LOW_PRIORITY, NULL);
			
		status_t status = resume_thread(thread);
		
		if (status != B_OK) {
			printf("failed to spawn thread: %ld : %ld\n", i, thread);
			continue;
		}
		
		if (status != B_OK)
			printf("failed to resume thread: %ld : %ld\n", i, thread);
	}
	
	acquire_sem_etc(sem, threads, 0, 0);		
	release_sem_etc(sem, threads, 0);
	delete_sem(sem);
		
	return 0;
}
